## spoa 1.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(spoa LANGUAGES CXX VERSION 1.1.3)

include(GNUInstallDirs)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -march=native")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

option(spoa_build_executable "Build spoa standalone tool" OFF)
option(spoa_build_tests "Build spoa unit tests" OFF)

# build SPOA as a static library by default
set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build all libraries as shared")

add_library(spoa
    src/alignment_engine.cpp
    src/graph.cpp
    src/simd_alignment_engine.cpp
    src/sisd_alignment_engine.cpp)

target_include_directories(spoa PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

set_target_properties(spoa
    PROPERTIES
    VERSION ${spoa_VERSION}
    SOVERSION ${spoa_VERSION})

install(TARGETS spoa DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/spoa DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# configure and install pkg-config file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/spoa.pc.in ${CMAKE_CURRENT_BINARY_DIR}/spoa-1.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/spoa-1.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

if (spoa_build_executable)
    add_executable(spoa_bin
        src/sequence.cpp
        src/main.cpp)

    if (NOT TARGET bioparser)
        add_subdirectory(vendor/bioparser EXCLUDE_FROM_ALL)
    endif()

    target_link_libraries(spoa_bin spoa bioparser)
    set_target_properties(spoa_bin PROPERTIES OUTPUT_NAME spoa)

    install(TARGETS spoa_bin DESTINATION ${CMAKE_INSTALL_BINDIR})
endif(spoa_build_executable)

if (spoa_build_tests)
    set(spoa_test_data_path ${PROJECT_SOURCE_DIR}/test/data/)
    configure_file(${PROJECT_SOURCE_DIR}/test/spoa_test_config.h.in
        ${PROJECT_BINARY_DIR}/config/spoa_test_config.h)
    include_directories(${PROJECT_BINARY_DIR}/config)
    include_directories(${PROJECT_SOURCE_DIR}/src)

    add_executable(spoa_test
        src/sequence.cpp
        test/spoa_test.cpp)

    if (NOT TARGET bioparser)
        add_subdirectory(vendor/bioparser EXCLUDE_FROM_ALL)
    endif()
    add_subdirectory(vendor/googletest/googletest EXCLUDE_FROM_ALL)

    target_link_libraries(spoa_test spoa bioparser gtest_main)
endif(spoa_build_tests)

=== debian/changelog ===
spoa (1.1.3-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Remove symbols file in backport

 -- Andreas Tille <tille@debian.org>  Wed, 24 Oct 2018 07:47:11 +0200

spoa (1.1.3-2) unstable; urgency=medium

  * Fix symbols file
    Closes: #905387
  * Standards-Version: 4.2.1
  * Add build-time test
  * Add autopkgtest

 -- Andreas Tille <tille@debian.org>  Fri, 19 Oct 2018 09:04:34 +0200

spoa (1.1.3-1) unstable; urgency=medium

  * Initial release (Closes: #901145)

 -- Andreas Tille <tille@debian.org>  Sat, 09 Jun 2018 23:05:58 +0200

=== debian/control ===
Source: spoa
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake,
               d-shlibs,
               rename,
               libbioparser-dev,
               libgtest-dev,
               zlib1g-dev
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/med-team/spoa
Vcs-Git: https://salsa.debian.org/med-team/spoa.git
Homepage: https://github.com/rvaser/spoa

Package: spoa
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: SIMD partial order alignment tool
 Spoa (SIMD POA) is a c++ implementation of the partial order alignment
 (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which
 is used to generate consensus sequences (as described in
 10.1093/bioinformatics/btg109). It supports three alignment modes: local
 (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
 (overlap).

Package: libspoa1.1.3
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: SIMD partial order alignment library
 Spoa (SIMD POA) is a c++ implementation of the partial order alignment
 (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which
 is used to generate consensus sequences (as described in
 10.1093/bioinformatics/btg109). It supports three alignment modes: local
 (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
 (overlap).
 .
 This package contains the shared library.

Package: libspoa-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libspoa1.1.3 (= ${binary:Version})
Description: SIMD partial order alignment library (development files)
 Spoa (SIMD POA) is a c++ implementation of the partial order alignment
 (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which
 is used to generate consensus sequences (as described in
 10.1093/bioinformatics/btg109). It supports three alignment modes: local
 (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
 (overlap).
 .
 This package contains the static library and the header files.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_BUILD_TYPE=Release \
                        -Dspoa_build_executable=ON \
                        -Dspoa_build_tests=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_install:
	dh_install
	file-rename 's/_static\.a/.a/' `find debian -name libspoa_static.a`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    --movedev debian/tmp/usr/lib/*/pkgconfig usr/lib/$(DEB_HOST_MULTIARCH) \
		    debian/tmp/usr/lib/*/*.so

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	`find . -name spoa_test`
	`find . -name spoa | grep bin` test/data/sample.fastq
endif

## spoa 1.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.2)
-project(spoa LANGUAGES CXX VERSION 1.1.3)
+project(spoa LANGUAGES CXX VERSION 1.1.5)
 
 include(GNUInstallDirs)

=== debian/changelog ===
spoa (1.1.5-1) unstable; urgency=medium

  * New upstream version
  * debhelper 12
  * Standards-Version: 4.3.0
  * Upstream changed ABI and we stick here to the broken way to set
    soversion = version but upstream was informed to invent better soversions
    https://github.com/rvaser/spoa/issues/14

 -- Andreas Tille <tille@debian.org>  Mon, 28 Jan 2019 21:13:39 +0100

spoa (1.1.3-4) unstable; urgency=medium

  * Set architecture to amd64 since the code is not really portable
    Closes: #913574

 -- Andreas Tille <tille@debian.org>  Thu, 06 Dec 2018 11:35:45 +0100

spoa (1.1.3-3) unstable; urgency=medium

  * Do not build with -march
    Closes: #911970
  * Remove trailing whitespace in debian/copyright
  * Mark two symbols as optional

 -- Andreas Tille <tille@debian.org>  Sat, 03 Nov 2018 07:38:44 +0100

=== debian/control ===
--- 
+++ 
@@ -3,20 +3,20 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper (>= 12~),
                cmake,
                d-shlibs,
                rename,
                libbioparser-dev,
                libgtest-dev,
                zlib1g-dev
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/med-team/spoa
 Vcs-Git: https://salsa.debian.org/med-team/spoa.git
 Homepage: https://github.com/rvaser/spoa
 
 Package: spoa
-Architecture: any
+Architecture: amd64
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: SIMD partial order alignment tool
@@ -27,8 +27,8 @@
  (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
  (overlap).
 
-Package: libspoa1.1.3
-Architecture: any
+Package: libspoa1.1.5
+Architecture: amd64
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
@@ -43,11 +43,11 @@
  This package contains the shared library.
 
 Package: libspoa-dev
-Architecture: any
+Architecture: amd64
 Section: libdevel
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libspoa1.1.3 (= ${binary:Version})
+         libspoa1.1.5 (= ${binary:Version})
 Description: SIMD partial order alignment library (development files)
  Spoa (SIMD POA) is a c++ implementation of the partial order alignment
  (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which

## spoa 3.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.2)
-project(spoa LANGUAGES CXX VERSION 1.1.5)
+project(spoa LANGUAGES CXX VERSION 3.0.0)
 
 include(GNUInstallDirs)
 
@@ -7,13 +7,18 @@
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -march=native")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
 option(spoa_build_executable "Build spoa standalone tool" OFF)
 option(spoa_build_tests "Build spoa unit tests" OFF)
+option(spoa_optimize_for_native "Buiold spoa with march=native" ON)
+
+if (spoa_optimize_for_native)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
+endif()
 
 # build SPOA as a static library by default
 set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build all libraries as shared")
@@ -53,7 +58,7 @@
     set_target_properties(spoa_bin PROPERTIES OUTPUT_NAME spoa)
 
     install(TARGETS spoa_bin DESTINATION ${CMAKE_INSTALL_BINDIR})
-endif(spoa_build_executable)
+endif()
 
 if (spoa_build_tests)
     set(spoa_test_data_path ${PROJECT_SOURCE_DIR}/test/data/)
@@ -69,7 +74,9 @@
     if (NOT TARGET bioparser)
         add_subdirectory(vendor/bioparser EXCLUDE_FROM_ALL)
     endif()
-    add_subdirectory(vendor/googletest/googletest EXCLUDE_FROM_ALL)
+    if (NOT TARGET gtest_main)
+        add_subdirectory(vendor/googletest/googletest EXCLUDE_FROM_ALL)
+    endif()
 
     target_link_libraries(spoa_test spoa bioparser gtest_main)
-endif(spoa_build_tests)
+endif()

=== debian/changelog ===
spoa (3.0.1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:26:10 +0100

spoa (3.0.1-1) unstable; urgency=medium

  * Fix symbols file
    Closes: #925835, #940280
  * New upstream version
  * debhelper-compat 12

 -- Andreas Tille <tille@debian.org>  Mon, 16 Sep 2019 13:24:48 +0200

spoa (3.0.0-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.4.0
  * Versioned Build-Depends: libbioparser-dev (>= 2.0)
  * Bump soversion to 3

 -- Andreas Tille <tille@debian.org>  Mon, 15 Jul 2019 16:12:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
                d-shlibs,
                rename,
-               libbioparser-dev,
+               libbioparser-dev (>= 2.0),
                libgtest-dev,
                zlib1g-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/med-team/spoa
 Vcs-Git: https://salsa.debian.org/med-team/spoa.git
 Homepage: https://github.com/rvaser/spoa
@@ -27,7 +27,7 @@
  (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
  (overlap).
 
-Package: libspoa1.1.5
+Package: libspoa3
 Architecture: amd64
 Section: libs
 Depends: ${shlibs:Depends},
@@ -47,7 +47,7 @@
 Section: libdevel
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libspoa1.1.5 (= ${binary:Version})
+         libspoa3 (= ${binary:Version})
 Description: SIMD partial order alignment library (development files)
  Spoa (SIMD POA) is a c++ implementation of the partial order alignment
  (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which

=== debian/watch ===
version=4

https://github.com/rvaser/spoa/releases .*/archive/@ANY_VERSION@@ARCHIVE_EXT@

## spoa 3.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,9 +14,12 @@
 
 option(spoa_build_executable "Build spoa standalone tool" OFF)
 option(spoa_build_tests "Build spoa unit tests" OFF)
-option(spoa_optimize_for_native "Buiold spoa with march=native" ON)
+option(spoa_optimize_for_native "Build spoa with -march=native" ON)
+option(spoa_optimize_for_portability "Build spoa with -msse4.1" OFF)
 
-if (spoa_optimize_for_native)
+if (spoa_optimize_for_portability)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
+elseif (spoa_optimize_for_native)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
 endif()

=== debian/changelog ===
spoa (3.0.2-3) unstable; urgency=medium

  [ Adrian Bunk ]
  * Fix getopt for architectures where char is unsigned
    Closes: #956809

 -- Andreas Tille <tille@debian.org>  Wed, 15 Apr 2020 16:12:16 +0200

spoa (3.0.2-2) unstable; urgency=medium

  * Team upload.
  * Add -DSIMDE_ENABLE_OPENMP
  * Really build anywhere
  * Only check the AMD64 symbols

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 14 Apr 2020 14:18:07 +0200

spoa (3.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Enable building on non x86-64 via SIMDe

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 13 Apr 2020 19:57:28 +0200

=== debian/control ===
--- 
+++ 
@@ -9,14 +9,16 @@
                rename,
                libbioparser-dev (>= 2.0),
                libgtest-dev,
-               zlib1g-dev
-Standards-Version: 4.4.0
+               zlib1g-dev,
+               libsimde-dev
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/spoa
 Vcs-Git: https://salsa.debian.org/med-team/spoa.git
 Homepage: https://github.com/rvaser/spoa
+Rules-Requires-Root: no
 
 Package: spoa
-Architecture: amd64
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: SIMD partial order alignment tool
@@ -28,7 +30,7 @@
  (overlap).
 
 Package: libspoa3
-Architecture: amd64
+Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
@@ -43,7 +45,7 @@
  This package contains the shared library.
 
 Package: libspoa-dev
-Architecture: amd64
+Architecture: any
 Section: libdevel
 Depends: ${shlibs:Depends},
          ${misc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -3,10 +3,12 @@
 # DH_VERBOSE := 1
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+export DEB_CXXFLAGS_MAINT_APPEND=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
 
 DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_BUILD_TYPE=Release \
                         -Dspoa_build_executable=ON \
-                        -Dspoa_build_tests=ON
+                        -Dspoa_build_tests=ON \
+                        -Dspoa_optimize_for_native=FALSE
 
 %:
 	dh $@

## spoa 3.4.0

=== debian/changelog ===
spoa (3.4.0-2) unstable; urgency=medium

  * Source-only upload

 -- Andreas Tille <tille@debian.org>  Fri, 07 Aug 2020 17:23:07 +0200

spoa (3.4.0-1) unstable; urgency=medium

  * New upstream version with new SOVERSION
    Closes: #966920
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 05 Aug 2020 09:02:12 +0200

spoa (3.0.2-5) unstable; urgency=medium

  * Team upload
  * Fix ppc64el FTBFS with altivec and c++ (Closes: #959880)

 -- Frédéric Bonnard <frediz@debian.org>  Thu, 07 May 2020 14:07:13 +0200

spoa (3.0.2-4) unstable; urgency=medium

  * Team upload.
  * Mark libspoa{3,-dev} as Multi-Arch: same
  * Simplify simde patch

  [ Etienne Mollier ]
  * Added patch for Gcc 10; assuming #959465 resolution:
    Closes: #957836

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 03 May 2020 14:02:30 +0200

## spoa 3.4.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.2)
-project(spoa LANGUAGES CXX VERSION 3.0.0)
+project(spoa LANGUAGES CXX VERSION 4.0.0)
 
 include(GNUInstallDirs)
 
@@ -16,30 +16,87 @@
 option(spoa_build_tests "Build spoa unit tests" OFF)
 option(spoa_optimize_for_native "Build spoa with -march=native" ON)
 option(spoa_optimize_for_portability "Build spoa with -msse4.1" OFF)
+option(spoa_use_simde "Use SIMDe library for porting vectorized code" OFF)
+option(spoa_use_simde_nonvec "Use SIMDe library for nonvectorized code" OFF)
+option(spoa_use_simde_openmp "Use SIMDe support for OpenMP SIMD" OFF)
+option(spoa_generate_dispatch "Use SIMDe to generate x86 dispatch" OFF)
 
-if (spoa_optimize_for_portability)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
-elseif (spoa_optimize_for_native)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
+if(NOT spoa_generate_dispatch) # optimization flags defeat the purpose of dispatching
+    if (spoa_optimize_for_portability)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
+    elseif (spoa_optimize_for_native)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
+    endif()
+endif()
+
+if (spoa_use_simde OR spoa_use_simde_nonvec OR spoa_use_simde_openmp OR spoa_generate_dispatch)
+    add_definitions(-DUSE_SIMDE -DSIMDE_ENABLE_NATIVE_ALIASES)
+    if (spoa_use_simde_nonvec)
+        add_definitions(-DSIMDE_NO_NATIVE)
+    endif()
+    if (spoa_use_simde_openmp)
+        add_definitions(-DSIMDE_ENABLE_OPENMP)
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp-simd")
+    endif()
+    if (spoa_generate_dispatch)
+        add_definitions(-DGEN_DISPATCH)
+    endif()
 endif()
 
 # build SPOA as a static library by default
 set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build all libraries as shared")
 
+list(APPEND INCLUDES
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
+    $<INSTALL_INTERFACE:include>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/vendor/simde>)
+
+# generating in also a dispatcher that handles both dispatching and non-dispatching case
+
 add_library(spoa
     src/alignment_engine.cpp
     src/graph.cpp
-    src/simd_alignment_engine.cpp
-    src/sisd_alignment_engine.cpp)
+    src/sisd_alignment_engine.cpp
+    src/dispatcher.cpp)
 
 target_include_directories(spoa PUBLIC
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-    $<INSTALL_INTERFACE:include>)
+    ${INCLUDES}
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/vendor/cpu_features/include>)
 
 set_target_properties(spoa
     PROPERTIES
     VERSION ${spoa_VERSION}
     SOVERSION ${spoa_VERSION})
+
+# in dispatching case, generate different optimized versions
+
+if (spoa_generate_dispatch)
+
+if (NOT TARGET cpu_features)
+    add_subdirectory(vendor/cpu_features)
+endif()
+
+list(APPEND Archs avx2 sse4.1 sse2)
+
+foreach(arch IN LISTS Archs)
+  add_library(spoa_${arch} OBJECT src/simd_alignment_engine_dispatch.cpp)
+  target_include_directories(spoa_${arch} PUBLIC ${INCLUDES})
+  set_target_properties(spoa_${arch} PROPERTIES COMPILE_FLAGS "-m${arch}")
+  if (BUILD_SHARED_LIBS)
+    set_property(TARGET spoa_${arch}
+      PROPERTY POSITION_INDEPENDENT_CODE ON)
+  endif()
+endforeach()
+
+add_dependencies(spoa
+  spoa_avx2
+  spoa_sse4.1
+  spoa_sse2)
+
+target_link_libraries(spoa
+    cpu_features)
+
+endif()
 
 install(TARGETS spoa DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/spoa DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== debian/changelog ===
spoa (3.4.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Disable use of native code generation (Closes: #969092)
  * Update symbols file

 -- Shayan Doust <hello@shayandoust.me>  Mon, 14 Sep 2020 12:43:15 +0100

spoa (3.4.0+ds-1) unstable; urgency=medium

  * Team upload.
  * Enable upstream's CPU dispatching
  * Switch to the full-source tarball from upstream for the cpu-features
    support

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 27 Aug 2020 16:45:15 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                d-shlibs,
                rename,
@@ -29,8 +29,9 @@
  (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
  (overlap).
 
-Package: libspoa3
+Package: libspoa4.0.0
 Architecture: any
+Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
@@ -46,10 +47,11 @@
 
 Package: libspoa-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libspoa3 (= ${binary:Version})
+         libspoa4.0.0 (= ${binary:Version})
 Description: SIMD partial order alignment library (development files)
  Spoa (SIMD POA) is a c++ implementation of the partial order alignment
  (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which

=== debian/rules ===
--- 
+++ 
@@ -3,15 +3,20 @@
 # DH_VERBOSE := 1
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
-export DEB_CXXFLAGS_MAINT_APPEND=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
+export DEB_CXXFLAGS_MAINT_APPEND=-O3
 
 DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_BUILD_TYPE=Release \
                         -Dspoa_build_executable=ON \
                         -Dspoa_build_tests=ON \
-                        -Dspoa_optimize_for_native=FALSE
+			-Dspoa_use_simde_nonvec=ON \
+			-Dspoa_use_simde_openmp=ON
+
+ifneq (,$(filter $(DEB_HOST_ARCH),i386 amd64))
+	DEB_CMAKE_EXTRA_FLAGS += -Dspoa_generate_dispatch=ON
+endif
 
 %:
-	dh $@
+	dh $@ --no-parallel
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)
@@ -23,7 +28,7 @@
 		    --multiarch \
 		    --devunversioned \
 		    --exclude-la \
-		    --movedev debian/tmp/usr/include/* usr/include \
+		    --movedev debian/tmp/usr/include/spoa usr/include \
 		    --movedev debian/tmp/usr/lib/*/pkgconfig usr/lib/$(DEB_HOST_MULTIARCH) \
 		    debian/tmp/usr/lib/*/*.so

## spoa 4.0.6+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project(spoa VERSION 4.0.6
             LANGUAGES CXX
             DESCRIPTION "Spoa is a c++ library (and tool) for SIMD vectorized partial order alignment.")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build all libraries as shared")

option(spoa_optimize_for_native "Build spoa with -march=native" ON)
option(spoa_optimize_for_portability "Build spoa with -msse4.1" OFF)
option(spoa_use_simde "Use SIMDe library for porting vectorized code" OFF)
option(spoa_use_simde_nonvec "Use SIMDe library for nonvectorized code" OFF)
option(spoa_use_simde_openmp "Use SIMDe support for OpenMP SIMD" OFF)
option(spoa_generate_dispatch "Use SIMDe to generate x86 dispatch" OFF)
if (NOT spoa_generate_dispatch)
  if (spoa_optimize_for_portability)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
  elseif (spoa_optimize_for_native)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
  endif ()
endif ()
if (spoa_use_simde OR
    spoa_use_simde_nonvec OR
    spoa_use_simde_openmp OR
    spoa_generate_dispatch)
  add_definitions(-DUSE_SIMDE -DSIMDE_ENABLE_NATIVE_ALIASES)
  if (spoa_use_simde_nonvec)
    add_definitions(-DSIMDE_NO_NATIVE)
  endif ()
  if (spoa_use_simde_openmp)
    add_definitions(-DSIMDE_ENABLE_OPENMP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp-simd")
  endif ()
  if (spoa_generate_dispatch)
    add_definitions(-DGENERATE_DISPATCH)
  endif ()
endif ()

if (NOT TARGET cereal)
  add_subdirectory(vendor/cereal EXCLUDE_FROM_ALL)
endif ()

add_library(${PROJECT_NAME}
  src/alignment_engine.cpp
  src/graph.cpp
  src/sisd_alignment_engine.cpp
  src/dispatcher.cpp)
target_include_directories(${PROJECT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/vendor/simde>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/vendor/cpu_features/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(${PROJECT_NAME}
  cereal)
if (BUILD_SHARED_LIBS)
  set_property(TARGET ${PROJECT_NAME} PROPERTY SOVERSION "7.0.0")
endif ()

if (spoa_generate_dispatch)
  if (NOT TARGET cpu_features)
    add_subdirectory(vendor/cpu_features EXCLUDE_FROM_ALL)
  endif ()

  list(APPEND ARCHITECTURES avx2 sse4.1 sse2)
  foreach(arch IN LISTS ARCHITECTURES)
    add_library(${PROJECT_NAME}_${arch} OBJECT
      src/simd_alignment_engine_dispatch.cpp)
    target_include_directories(${PROJECT_NAME}_${arch} PUBLIC
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/vendor/simde>
      $<INSTALL_INTERFACE:include>)
    target_link_libraries(${PROJECT_NAME}_${arch}
      cereal)
    set_target_properties(${PROJECT_NAME}_${arch} PROPERTIES
      COMPILE_FLAGS "-m${arch}")
    if (BUILD_SHARED_LIBS)
      set_property(TARGET ${PROJECT_NAME}_${arch}
        PROPERTY POSITION_INDEPENDENT_CODE ON)
    endif ()
  endforeach ()

  add_dependencies(${PROJECT_NAME}
    ${PROJECT_NAME}_avx2
    ${PROJECT_NAME}_sse4.1
    ${PROJECT_NAME}_sse2)

  target_link_libraries(${PROJECT_NAME}
    cpu_features)
endif ()

include(GNUInstallDirs)
install(TARGETS ${PROJECT_NAME}
  DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/spoa
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# configure and install pkg-config file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/spoa.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/spoa-1.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/spoa-1.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

option(spoa_build_executable "Build spoa standalone tool" OFF)
if (spoa_build_executable)
  if (NOT TARGET biosoup)
    add_subdirectory(vendor/bioparser/vendor/biosoup EXCLUDE_FROM_ALL)
  endif ()
  if (NOT TARGET bioparser)
    add_subdirectory(vendor/bioparser EXCLUDE_FROM_ALL)
  endif ()
  add_executable(${PROJECT_NAME}_exe
    src/main.cpp)
  target_link_libraries(${PROJECT_NAME}_exe
    ${PROJECT_NAME}
    bioparser
    biosoup)
  target_compile_definitions(${PROJECT_NAME}_exe PRIVATE
    SPOA_VERSION="v${PROJECT_VERSION}")
  set_property(TARGET ${PROJECT_NAME}_exe PROPERTY
    OUTPUT_NAME ${PROJECT_NAME})

  install(TARGETS ${PROJECT_NAME}_exe
    DESTINATION ${CMAKE_INSTALL_BINDIR})
endif ()

option(spoa_build_tests "Build spoa unit tests" OFF)
if (spoa_build_tests)
  find_package(GTest REQUIRED)
  if (NOT TARGET biosoup)
    add_subdirectory(vendor/bioparser/vendor/biosoup EXCLUDE_FROM_ALL)
  endif ()
  if (NOT TARGET bioparser)
    add_subdirectory(vendor/bioparser EXCLUDE_FROM_ALL)
  endif ()
  include_directories(${PROJECT_SOURCE_DIR}/src)
  add_executable(${PROJECT_NAME}_test
    test/spoa_test.cpp)
  target_link_libraries(${PROJECT_NAME}_test
    ${PROJECT_NAME}
    bioparser
    biosoup
    GTest::Main)
  target_compile_definitions(${PROJECT_NAME}_test PRIVATE
    SPOA_DATA_PATH="${PROJECT_SOURCE_DIR}/test/data/sample.fastq.gz")
endif ()

=== vendor/cpu_features/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# option() honors normal variables.
# see: https://cmake.org/cmake/help/git-stage/policy/CMP0077.html
if(POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif()

project(CpuFeatures VERSION 0.1.0 LANGUAGES C)

set(CMAKE_C_STANDARD 99)

# Default Build Type to be Release
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# BUILD_TESTING is a standard CMake variable, but we declare it here to make it
# prominent in the GUI.
option(BUILD_TESTING "Enable test (depends on googletest)." OFF)
# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to make
# it prominent in the GUI.
# cpu_features uses bit-fields which are - to some extends - implementation-defined (see https://en.cppreference.com/w/c/language/bit_field). 
# As a consequence it is discouraged to use cpu_features as a shared library because different compilers may interpret the code in different ways. 
# Prefer static linking from source whenever possible.
option(BUILD_SHARED_LIBS "Build library as shared." OFF)
# PIC
option(BUILD_PIC "Build with Position Independant Code." OFF) # Default is off at least for GCC

# Force PIC on unix when building shared libs
# see: https://en.wikipedia.org/wiki/Position-independent_code
if(BUILD_SHARED_LIBS AND UNIX)
  set(BUILD_PIC ON)
endif()

include(CheckIncludeFile)
include(CheckSymbolExists)
include(GNUInstallDirs)

macro(setup_include_and_definitions TARGET_NAME)
  target_include_directories(${TARGET_NAME}
    PUBLIC  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    PRIVATE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/internal>
  )
  target_compile_definitions(${TARGET_NAME}
    PUBLIC STACK_LINE_READER_BUFFER_SIZE=1024
  )
endmacro()

set(PROCESSOR_IS_MIPS FALSE)
set(PROCESSOR_IS_ARM FALSE)
set(PROCESSOR_IS_AARCH64 FALSE)
set(PROCESSOR_IS_X86 FALSE)
set(PROCESSOR_IS_POWER FALSE)

if(CMAKE_SYSTEM_PROCESSOR MATCHES "^mips")
  set(PROCESSOR_IS_MIPS TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^arm")
  set(PROCESSOR_IS_ARM TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^aarch64")
  set(PROCESSOR_IS_AARCH64 TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(x86_64)|(AMD64|amd64)|(^i.86$)")
  set(PROCESSOR_IS_X86 TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(powerpc|ppc)")
  set(PROCESSOR_IS_POWER TRUE)
endif()

macro(add_cpu_features_headers_and_sources HDRS_LIST_NAME SRCS_LIST_NAME)
  list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpu_features_macros.h)
  list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpu_features_cache_info.h)
  if(PROCESSOR_IS_MIPS)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_mips.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/src/cpuinfo_mips.c)
  elseif(PROCESSOR_IS_ARM)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_arm.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/src/cpuinfo_arm.c)
  elseif(PROCESSOR_IS_AARCH64)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_aarch64.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/src/cpuinfo_aarch64.c)
  elseif(PROCESSOR_IS_X86)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_x86.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/internal/cpuid_x86.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/src/cpuinfo_x86.c)
  elseif(PROCESSOR_IS_POWER)
      list(APPEND ${HDRS_LIST_NAME} ${PROJECT_SOURCE_DIR}/include/cpuinfo_ppc.h)
      list(APPEND ${SRCS_LIST_NAME} ${PROJECT_SOURCE_DIR}/src/cpuinfo_ppc.c)
  else()
    message(FATAL_ERROR "Unsupported architectures ${CMAKE_SYSTEM_PROCESSOR}")
  endif()
endmacro()

if(UNIX AND PROCESSOR_IS_X86)
  include(CheckCSourceCompiles)
  check_c_source_compiles("
    #include <stdlib.h>
    int main(void)
    {
      __builtin_cpu_init();
    }" HAVE_CPU_INIT)
  if(NOT HAVE_CPU_INIT)
    check_include_file(sys/utsname.h HAVE_UTSNAME_H)
  endif()
endif()

#
# library : utils
#

add_library(utils OBJECT
  ${PROJECT_SOURCE_DIR}/include/internal/bit_utils.h
  ${PROJECT_SOURCE_DIR}/include/internal/filesystem.h
  ${PROJECT_SOURCE_DIR}/include/internal/stack_line_reader.h
  ${PROJECT_SOURCE_DIR}/include/internal/string_view.h
  ${PROJECT_SOURCE_DIR}/src/filesystem.c
  ${PROJECT_SOURCE_DIR}/src/stack_line_reader.c
  ${PROJECT_SOURCE_DIR}/src/string_view.c
)
set_property(TARGET utils PROPERTY POSITION_INDEPENDENT_CODE ${BUILD_PIC})
setup_include_and_definitions(utils)

#
# library : unix_based_hardware_detection
#

if(UNIX)
  add_library(unix_based_hardware_detection OBJECT
    ${PROJECT_SOURCE_DIR}/include/internal/hwcaps.h
    ${PROJECT_SOURCE_DIR}/include/internal/unix_features_aggregator.h
    ${PROJECT_SOURCE_DIR}/src/hwcaps.c
    ${PROJECT_SOURCE_DIR}/src/unix_features_aggregator.c
  )
  setup_include_and_definitions(unix_based_hardware_detection)
  check_include_file(dlfcn.h HAVE_DLFCN_H)
  if(HAVE_DLFCN_H)
    target_compile_definitions(unix_based_hardware_detection PRIVATE HAVE_DLFCN_H)
  endif()
  check_symbol_exists(getauxval "sys/auxv.h" HAVE_STRONG_GETAUXVAL)
  if(HAVE_STRONG_GETAUXVAL)
    target_compile_definitions(unix_based_hardware_detection PRIVATE HAVE_STRONG_GETAUXVAL)
  endif()
  set_property(TARGET unix_based_hardware_detection PROPERTY POSITION_INDEPENDENT_CODE ${BUILD_PIC})
endif()

#
# library : cpu_features
#
set (CPU_FEATURES_HDRS)
set (CPU_FEATURES_SRCS)
add_cpu_features_headers_and_sources(CPU_FEATURES_HDRS CPU_FEATURES_SRCS)
list(APPEND CPU_FEATURES_SRCS $<TARGET_OBJECTS:utils>)
if(NOT PROCESSOR_IS_X86 AND UNIX)
  list(APPEND CPU_FEATURES_SRCS $<TARGET_OBJECTS:unix_based_hardware_detection>)
endif()
add_library(cpu_features ${CPU_FEATURES_HDRS} ${CPU_FEATURES_SRCS})
set_target_properties(cpu_features PROPERTIES PUBLIC_HEADER "${CPU_FEATURES_HDRS}")
setup_include_and_definitions(cpu_features)
target_link_libraries(cpu_features PUBLIC ${CMAKE_DL_LIBS})
set_property(TARGET cpu_features PROPERTY POSITION_INDEPENDENT_CODE ${BUILD_PIC})
target_include_directories(cpu_features
  PUBLIC $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/cpu_features>
)
if(PROCESSOR_IS_X86)
  if(HAVE_CPU_INIT)
    target_compile_definitions(cpu_features PRIVATE HAVE_CPU_INIT)
  else()
    if(HAVE_UTSNAME_H)
      target_compile_definitions(cpu_features PRIVATE HAVE_UTSNAME_H)
    endif()
    if(APPLE)
      target_compile_definitions(cpu_features PRIVATE HAVE_SYSCTLBYNAME)
    endif()
  endif()
endif()
add_library(CpuFeature::cpu_features ALIAS cpu_features)

#
# program : list_cpu_features
#

add_executable(list_cpu_features ${PROJECT_SOURCE_DIR}/src/utils/list_cpu_features.c)
target_link_libraries(list_cpu_features PRIVATE cpu_features)
add_executable(CpuFeature::list_cpu_features ALIAS list_cpu_features)

#
# ndk_compat
#

if(ANDROID)
add_subdirectory(ndk_compat)
endif()

#
# tests
#

include(CTest)
if(BUILD_TESTING)
  # Automatically incorporate googletest into the CMake Project if target not
  # found.
  enable_language(CXX)
  
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF) # prefer use of -std11 instead of -gnustd11
  
  if(NOT TARGET gtest OR NOT TARGET gmock_main)
    # Download and unpack googletest at configure time.
    configure_file(
      cmake/googletest.CMakeLists.txt.in
      googletest-download/CMakeLists.txt
    )

    execute_process(
      COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
      RESULT_VARIABLE result
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download)

    if(result)
      message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()

    execute_process(
      COMMAND ${CMAKE_COMMAND} --build .
      RESULT_VARIABLE result
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download)

    if(result)
      message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()

    # Prevent overriding the parent project's compiler/linker settings on
    # Windows.
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    # Add googletest directly to our build. This defines the gtest and
    # gtest_main targets.
    add_subdirectory(${CMAKE_BINARY_DIR}/googletest-src
                     ${CMAKE_BINARY_DIR}/googletest-build
                     EXCLUDE_FROM_ALL)
  endif()

  add_subdirectory(test)
endif()

#
# Install cpu_features and list_cpu_features
#

include(GNUInstallDirs)
install(TARGETS cpu_features list_cpu_features
  EXPORT CpuFeaturesTargets
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cpu_features
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)
install(EXPORT CpuFeaturesTargets
  NAMESPACE CpuFeatures::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeatures
  COMPONENT Devel
)
include(CMakePackageConfigHelpers)
configure_package_config_file(cmake/CpuFeaturesConfig.cmake.in
  "${PROJECT_BINARY_DIR}/CpuFeaturesConfig.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeatures"
  NO_SET_AND_CHECK_MACRO
  NO_CHECK_REQUIRED_COMPONENTS_MACRO
)
write_basic_package_version_file(
  "${PROJECT_BINARY_DIR}/CpuFeaturesConfigVersion.cmake"
  COMPATIBILITY SameMajorVersion
)
install(
  FILES
    "${PROJECT_BINARY_DIR}/CpuFeaturesConfig.cmake"
    "${PROJECT_BINARY_DIR}/CpuFeaturesConfigVersion.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeatures"
  COMPONENT Devel
)

=== vendor/cpu_features/ndk_compat/CMakeLists.txt ===

#
# library : NDK compat
#
find_package(Threads REQUIRED)
set (NDK_COMPAT_HDRS cpu-features.h)
set (NDK_COMPAT_SRCS
  cpu-features.c
  $<TARGET_OBJECTS:utils>
  $<TARGET_OBJECTS:unix_based_hardware_detection>
)
# Note that following `add_cpu_features_headers_and_sources` will use
# NDK_COMPAT_SRCS in lieu of NDK_COMPAT_HDRS because we don't want cpu_features
# headers to be installed alongside ndk_compat.
add_cpu_features_headers_and_sources(NDK_COMPAT_SRCS NDK_COMPAT_SRCS)
add_library(ndk_compat ${NDK_COMPAT_HDRS} ${NDK_COMPAT_SRCS})
setup_include_and_definitions(ndk_compat)
target_link_libraries(ndk_compat PUBLIC ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(ndk_compat PROPERTIES PUBLIC_HEADER "${NDK_COMPAT_HDRS}")

include(GNUInstallDirs)
install(TARGETS ndk_compat
  EXPORT CpuFeaturesNdkCompatTargets
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ndk_compat
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)
install(EXPORT CpuFeaturesNdkCompatTargets
  NAMESPACE CpuFeatures::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeaturesNdkCompat
  COMPONENT Devel
)
include(CMakePackageConfigHelpers)
configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/CpuFeaturesNdkCompatConfig.cmake.in
  "${PROJECT_BINARY_DIR}/CpuFeaturesNdkCompatConfig.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeaturesNdkCompat"
  NO_SET_AND_CHECK_MACRO
  NO_CHECK_REQUIRED_COMPONENTS_MACRO
)
write_basic_package_version_file(
  "${PROJECT_BINARY_DIR}/CpuFeaturesNdkCompatConfigVersion.cmake"
  COMPATIBILITY SameMajorVersion
)
install(
  FILES
    "${PROJECT_BINARY_DIR}/CpuFeaturesNdkCompatConfig.cmake"
    "${PROJECT_BINARY_DIR}/CpuFeaturesNdkCompatConfigVersion.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/CpuFeaturesNdkCompat"
  COMPONENT Devel
)

#
# program : NDK compat test program
#
if(ENABLE_TESTING)
  add_executable(ndk-compat-test ndk-compat-test.c)
  target_link_libraries(ndk-compat-test PRIVATE ndk_compat)
endif()

=== vendor/cpu_features/test/CMakeLists.txt ===
#
# libraries for tests
#

include_directories(../include)
add_definitions(-DCPU_FEATURES_TEST)

##------------------------------------------------------------------------------
add_library(string_view ../src/string_view.c)
##------------------------------------------------------------------------------
add_library(filesystem_for_testing filesystem_for_testing.cc)
target_compile_definitions(filesystem_for_testing PUBLIC CPU_FEATURES_MOCK_FILESYSTEM)
##------------------------------------------------------------------------------
add_library(hwcaps_for_testing hwcaps_for_testing.cc)
target_compile_definitions(hwcaps_for_testing PUBLIC CPU_FEATURES_MOCK_GET_ELF_HWCAP_FROM_GETAUXVAL)
target_link_libraries(hwcaps_for_testing filesystem_for_testing)
##------------------------------------------------------------------------------
add_library(stack_line_reader ../src/stack_line_reader.c)
target_compile_definitions(stack_line_reader PUBLIC STACK_LINE_READER_BUFFER_SIZE=1024)
target_link_libraries(stack_line_reader string_view)
##------------------------------------------------------------------------------
add_library(stack_line_reader_for_test ../src/stack_line_reader.c)
target_compile_definitions(stack_line_reader_for_test PUBLIC STACK_LINE_READER_BUFFER_SIZE=16)
target_link_libraries(stack_line_reader_for_test string_view filesystem_for_testing)
##------------------------------------------------------------------------------
add_library(all_libraries ../src/stack_line_reader.c ../src/unix_features_aggregator.c)
target_link_libraries(all_libraries hwcaps_for_testing stack_line_reader string_view)

#
# tests
#
link_libraries(gtest gmock_main)

## bit_utils_test
add_executable(bit_utils_test bit_utils_test.cc)
target_link_libraries(bit_utils_test)
add_test(NAME bit_utils_test COMMAND bit_utils_test)
##------------------------------------------------------------------------------
## string_view_test
add_executable(string_view_test string_view_test.cc ../src/string_view.c)
target_link_libraries(string_view_test string_view)
add_test(NAME string_view_test COMMAND string_view_test)
##------------------------------------------------------------------------------
## stack_line_reader_test
add_executable(stack_line_reader_test stack_line_reader_test.cc)
target_link_libraries(stack_line_reader_test stack_line_reader_for_test)
add_test(NAME stack_line_reader_test COMMAND stack_line_reader_test)
##------------------------------------------------------------------------------
## unix_features_aggregator_test
add_executable(unix_features_aggregator_test unix_features_aggregator_test.cc)
target_link_libraries(unix_features_aggregator_test all_libraries)
add_test(NAME unix_features_aggregator_test COMMAND unix_features_aggregator_test)
##------------------------------------------------------------------------------
## cpuinfo_x86_test
if(PROCESSOR_IS_X86)
  add_executable(cpuinfo_x86_test cpuinfo_x86_test.cc ../src/cpuinfo_x86.c)
  target_compile_definitions(cpuinfo_x86_test PUBLIC CPU_FEATURES_MOCK_CPUID_X86)
  target_link_libraries(cpuinfo_x86_test all_libraries)
  add_test(NAME cpuinfo_x86_test COMMAND cpuinfo_x86_test)
endif()
##------------------------------------------------------------------------------
## cpuinfo_arm_test
if(PROCESSOR_IS_ARM)
  add_executable(cpuinfo_arm_test cpuinfo_arm_test.cc ../src/cpuinfo_arm.c)
  target_link_libraries(cpuinfo_arm_test all_libraries)
  add_test(NAME cpuinfo_arm_test COMMAND cpuinfo_arm_test)
endif()
##------------------------------------------------------------------------------
## cpuinfo_aarch64_test
if(PROCESSOR_IS_AARCH64)
  add_executable(cpuinfo_aarch64_test cpuinfo_aarch64_test.cc ../src/cpuinfo_aarch64.c)
  target_link_libraries(cpuinfo_aarch64_test all_libraries)
  add_test(NAME cpuinfo_aarch64_test COMMAND cpuinfo_aarch64_test)
endif()
##------------------------------------------------------------------------------
## cpuinfo_mips_test
if(PROCESSOR_IS_MIPS)
  add_executable(cpuinfo_mips_test cpuinfo_mips_test.cc  ../src/cpuinfo_mips.c)
  target_link_libraries(cpuinfo_mips_test all_libraries)
  add_test(NAME cpuinfo_mips_test COMMAND cpuinfo_mips_test)
endif()
##------------------------------------------------------------------------------
## cpuinfo_ppc_test
if(PROCESSOR_IS_POWER)
  add_executable(cpuinfo_ppc_test cpuinfo_ppc_test.cc  ../src/cpuinfo_ppc.c)
  target_link_libraries(cpuinfo_ppc_test all_libraries)
  add_test(NAME cpuinfo_ppc_test COMMAND cpuinfo_ppc_test)
endif()

## spoa 4.0.6+ds2

=== debian/changelog ===
spoa (4.0.6+ds2-1) unstable; urgency=medium

  * Team upload.
  * libspoa-dev needs libcereal-dev as well.
  * debian/copyright: exclude upstream's copy of cpu_features
  * debian/patches/deb_cpu_features: use cpu_features from libcpu-
    features-dev

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 12 Jan 2021 11:17:23 +0100

spoa (4.0.6+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debian/patches/shared_lib_creation.patch: incorporated upstream,
    deleted.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 08 Jan 2021 13:25:47 +0100

spoa (4.0.5+ds-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version

  [ Michael R. Crusoe ]
  * Standards-Version: 4.5.1 (routine-update)
  * Refresh patches
  * rename lib package to match new SO name
  * build-dep on libcereal-dev and newer libbioparser-dev
  * Drop no_march_native.patch in favor of setting the option in debian/rules
  * debian/rules: test/data/sample.fastq is now gziped upstream
  * Update symbols for new version
  * debian/patches/shared_and_static.patch: updated courtesy of upstream
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 07 Jan 2021 15:47:48 +0100

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,13 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                d-shlibs,
-               rename,
-               libbioparser-dev (>= 2.0),
+               libbioparser-dev (>= 3.0),
+               libcereal-dev,
                libgtest-dev,
                zlib1g-dev,
-               libsimde-dev
-Standards-Version: 4.5.0
+               libsimde-dev,
+               libcpu-features-dev
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/spoa
 Vcs-Git: https://salsa.debian.org/med-team/spoa.git
 Homepage: https://github.com/rvaser/spoa
@@ -29,7 +30,7 @@
  (Smith-Waterman), global (Needleman-Wunsch) and semi-global alignment
  (overlap).
 
-Package: libspoa4.0.0
+Package: libspoa7.0.0
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -51,7 +52,8 @@
 Section: libdevel
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libspoa4.0.0 (= ${binary:Version})
+         libspoa7.0.0 (= ${binary:Version}),
+         libcereal-dev
 Description: SIMD partial order alignment library (development files)
  Spoa (SIMD POA) is a c++ implementation of the partial order alignment
  (POA) algorithm (as described in 10.1093/bioinformatics/18.3.452) which
